#include <windows.h>
#include <crtdbg.h>
#include <vector>


//! t@C std::vector<BYTE> ɓǂݍށB
bool LoadFile(const wchar_t* i_file_name, std::vector<BYTE>& o_data)
{
  bool            retval      = false;
  HANDLE          file_handle = INVALID_HANDLE_VALUE;
  LARGE_INTEGER   file_size   = { 0 };
  DWORD           read_size   = 0;

  do
  {
    file_handle = CreateFileW(
                    i_file_name,
                    GENERIC_READ,
                    FILE_SHARE_READ,
                    NULL,
                    OPEN_EXISTING,
                    FILE_ATTRIBUTE_NORMAL,
                    NULL
                  );
    if( file_handle == INVALID_HANDLE_VALUE )
    {
      _RPTF2(_CRT_WARN,
             "unable to open file[%s] : 0x%08X.\n",
             i_file_name, GetLastError()
            );
      break;
    }
    
    if( GetFileSizeEx(file_handle, &file_size) == FALSE )
    {
      _RPTF1(_CRT_WARN, "unable to get file size : 0x%08X.\n", GetLastError());
      break;
    }
    
    if( file_size.HighPart
    ||  file_size.LowPart > LONG_MAX
    ||  file_size.LowPart == 0 )
    {
      _RPTF0(_CRT_WARN, "invalid file size\n");
      break;
    }
    
    o_data.resize(file_size.LowPart, 0);
    if( ReadFile(file_handle, &o_data[0], file_size.LowPart, &read_size, NULL)
        == FALSE )
    {
      _RPTF1(_CRT_WARN, "unable to read file : 0x%08X.\n", GetLastError());
      break;
    }
    
    retval = true;
  }
  while( 0 );
  
  if( file_handle != INVALID_HANDLE_VALUE )
  {
    CloseHandle(file_handle);
    file_handle = INVALID_HANDLE_VALUE;
  }

  return retval;
}

