#ifndef __PEFILE_H_INCLUDED__
#define __PEFILE_H_INCLUDED__
#include <pshpack1.h>


//! GetImportSymbols() ŕԂ vector ̗vf̌^
struct ImportSymbol
{
  DWORD   iat_entry_rva;    //!< IAT Gg RVA B
  void**  iat_entry_p;      //!< IAT Ggւ̃|C^B
  WORD    hint;             //!< qg
  union
  {
    struct
    {
      WORD import_by_name;  //!<  0 ̏ꍇAOɂC|[gB
      WORD ordinal;         //!< import_by_name  0 ̏ꍇA
    };
    const char* name;       //!< OɂC|[g̏ꍇA̖OB
  };
};


//! GetExportSymbols() ŕԂ vector ̗vf̌^
struct ExportSymbol
{
  DWORD         symbol_rva;   //!< GNX|[gV{ RVA B
  void*         symbol_p;     //!< GNX|[gV{ւ̃|C^B
  DWORD         ordinal;      //!< B
  const char*   name;         //!< GNX|[gV{B݂̂̏ꍇ "" B
  const char*   forwarded_to; //!< ]Ăꍇ͓]於BȂꍇ "" B
};


//! PE t@C擾邽߂̃NXB
class PEFile
{
public:
  //! RXgN^BɊJǂ GetLoadBase() ŊmFB
  explicit PEFile(const wchar_t* i_file_name);
  //! W[nh̃RXgN^B
  explicit PEFile(HMODULE i_module_handle);
  //! fXgN^
  virtual ~PEFile();
  
  //! [hAhX擾B
  BYTE* GetLoadBase();
  
  //! DOS wb_ւ̃|C^擾B
  IMAGE_DOS_HEADER* GetDosHeaderP();
  //! NT wb_ւ̃|C^擾B
  IMAGE_NT_HEADERS32* GetNtHeadersP();
  //! t@Cwb_ւ̃|C^擾B
  IMAGE_FILE_HEADER* GetFileHeaderP();
  //! IvViwb_ւ̃|C^擾B
  IMAGE_OPTIONAL_HEADER32* GetOptionalHeaderP();
  //! i_index Ԗڂ̃ZNVwb_ւ̃|C^擾B
  IMAGE_SECTION_HEADER* GetSectionHeader(int i_index);
  
  //! i_index Ԗڂ̃f[^fBNgGgwf[^ւ̃|C^擾B
  BYTE* GetDirEntryDataP(int i_index);
  //! i_index Ԗڂ̃f[^fBNgGgwf[^ւ̃TCY擾B
  DWORD GetDirEntryDataSize(int i_index);
  
  //! C|[gfBNgւ̃|C^擾B
  IMAGE_IMPORT_DESCRIPTOR* GetImportDirP();
  //! C|[gĂ DLL 擾B
  std::vector<const char*> GetImportDllNames();
  //! w肵 DLL C|[gĂV{擾B
  std::vector<ImportSymbol> GetImportSymbols(const char* i_dll_name);
  //! C|[gV{tbNBꍇ IAT Ggւ̃|C^ԂB
  void** HookImportSymbol(void* i_old_p, void* i_new_p);

  //! GNX|[gfBNgւ̃|C^擾B
  IMAGE_EXPORT_DIRECTORY* GetExportDirP();
  //! GNX|[gV{擾B
  std::vector<ExportSymbol> GetExportSymbols();
  //! GNX|[gV{ւ̃|C^擾B
  void* GetExportSymbolPFromOrdinal(WORD i_ordinal);
  //! GNX|[gV{ւ̃|C^擾B
  void* GetExportSymbolPFromName(const char* i_name);
  
protected:
  //! C[Wt@CɃ}bsOB
  static BYTE* MapImage(const wchar_t* i_file_name);
  
  //! RVA |C^ɕϊev[g\bh
  template<class T> T GetDataP(DWORD i_rva)
  { return reinterpret_cast<T>(m_load_base + i_rva); }

  //! i_index Ԗڂ̃GNX|[gV{̖O擾Bsꍇ "" ԂB
  const char* FindExportSymbolName(size_t i_index);
  //! i_index Ԗڂ̃GNX|[gV{ RVA 擾B
  DWORD GetExportSymbolRVA(size_t i_index);
  //! GNX|[g]Ă邩ǂׂB
  bool IsExportForwarded(DWORD i_symbol_rva);
  
protected:
  bool                   m_need_to_free;    //!< m_load_base Kv邩H
  BYTE*                  m_load_base;       //!< C[W̃[hꂽAhX
  IMAGE_DOS_HEADER*      m_dos_header_p;    //!< DOS wb_ւ̃|C^
  IMAGE_NT_HEADERS*      m_nt_headers_p;    //!< NT wb_ւ̃|C^
  IMAGE_SECTION_HEADER*  m_section_table_p; //!< ZNVe[uւ̃|C^
};


#include <poppack.h>
#endif
